var pe = null;

var app = {
    // Application Constructor
    initialize: function () {
        this.bindEvents();
    },
    setPokktConfig: function () {
        var appid = document.getElementById("appid").value;
        var seckey = document.getElementById("seckey").value;
        localStorage.setItem("POKKTAPPID",appid);
        localStorage.setItem("POKKTSECKEY",seckey);
        pe.setPokktConfig(appid, seckey);
    },
    setDataAccessConsent: function () {
        var isGDPRAplicable = document.getElementById("gdprapplicable").checked === true;
        var isGDPRConsentAvailable = document.getElementById("gdprconsentavailable").checked === true;
        var gdprConsent = {GDPRApplicable:isGDPRAplicable, GDPRConsentAvailable:isGDPRConsentAvailable};
        pe.setDataAccessConsent(JSON.stringify(gdprConsent));
    },

    setUserDetails: function () {
       var userDetails = pe.createUserDetails();
       userDetails.age = '28';
       userDetails.birthday = '1-1-90';
       userDetails.education = 'graduate';
       userDetails.emailAddress = 'a@a.com';
       userDetails.employment = 'salaried';
       userDetails.facebookId = 'NA';
       userDetails.twitterHandle = 'NA';
       userDetails.location = 'india';
       userDetails.maritalStatus = 'married';
       userDetails.maturityRating = '13+';
       userDetails.name = 'XXX';
       userDetails.mobileNo = '1234567890';
       userDetails.sex = 'male';
       userDetails.nationality = 'indian';
       pe.setUserDetails(JSON.stringify(userDetails));
    },

    // Bind Event Listeners
    bindEvents: function () {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },

    onDeviceReady: function () {
        console.log('device is ready!');

        pe = window.plugins.pokktExtension;

    },
    onClickBack: function () {
        history.back();
    }
};
